libname dinn "c:\";

  /*  Program for Figures 2 to 7     */
  /*  and web appendix Figures B1 to B4 */ 


%let controle= PASSEQUANDcj='jamais ou n sa' ; 
 
data AA9209;set dinn.D5part(where=(DOUBLEDIF5=1)
                            keep=DOUBLEDIF5 AN S DURTRAVref DURTRAVrefcj SCOcj AGEcj AGEcj2	YEARTREATED
                                 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj TYPEENQ
                                 NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj
                                 PASSEQUANDcj cjYEARTREATED SALPRIVEcj cjTREATED PostcjTREATED A1995-A2009 TREND 
                                 TREATEDAutre TREATED UNKNOWN PostTREATED A1995-A2009 DURTRAV DATEpasse	PASSEQUAND
                                 SCO AGE AGE2 SALPRIVE NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G 	
                                 NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc SALARIE );	 
if TYPEENQ='EEC' then do;
  if S='1' then do; DURTRAVREF=DURTRAVREF-1.02; DURTRAVREFcj=DURTRAVREFcj-1.41;end;
  if S='2' then do; DURTRAVREF=DURTRAVREF-1.41; DURTRAVREFcj=DURTRAVREFcj-1.02;end; end;  
length DUREE 6;
  if cjTREATED=1 then DUREE=AN-cjYEARTREATED; else DUREE=0;
length DUREEego 6; if TREATED=1 then DUREEego=AN-YEARTREATED; else DUREEego=0;
length GROUPE3 $ 6;	if cjTREATED=0 then GROUPE3=AN!!'00';
   else if (cjTREATED=1 and postcjTREATED=0) then GROUPE3=AN!!'10';
   else if (cjTREATED=1 and postcjTREATED=1) then GROUPE3=AN!!'11';	
length DURDIFF 6;DURDIFF=DURTRAVref-DURTRAV;   
drop YEARTREATED DOUBLEDIF5;
run; 

proc sort data=AA9209; by S AN ;

   
%let suppvari=SCOcj AGEcj AGEcj2 NAFG16Acj NAFG16Bcj NAFG16Ccj NAFG16Dcj NAFG16ecj NAFG16Fcj NAFG16Gcj
              NAFG16Hcj NAFG16Jcj NAFG16Kcj NAFG16Lcj  NAFG16Ncj NAFG16Pcj NAFG16Qcj NAFG16Rcj NAFG16inccj;
   
%let suppvareg=SCO AGE AGE2 NAFG16A NAFG16B NAFG16C NAFG16D NAFG16e NAFG16F NAFG16G
              NAFG16H NAFG16J NAFG16K NAFG16L NAFG16N NAFG16P NAFG16Q NAFG16R NAFG16inc;


proc SURVEYREG data=AA9209; 
cluster GROUPE3;
model DURTRAVref=SALARIE SALPRIVE SALPRIVEcj  A1995-A2009 
               TREATEDAutre TREATED UNKNOWN    &suppvari &suppvareg ;
by S;
output out=RES9209 R=DURTRAVrefNET;   
run;

   /* for the control group */
proc summary data=RES9209(where=(&controle));
var DURTRAVref DURTRAVrefNET DURTRAVrefCJ;
by S AN;
output out=RESU(drop=_TYPE_ _FREQ_) mean=DURTRAVref_co DURTRAVrefNET_co DURTRAVrefCJ_co;
proc print data=RESU;
title "workweek duration - control group";
run;

	 /* Web appendix Figures B1 and B2 and Figures 2, 4, 5 and 7   */
data ET;merge RES9209(in=_i1 where=(cjYEARTREATED ne '    ')) RESU;by S AN;
  if _i1; 
length DIFFref  DIFFrefNET 8;
   DIFFref=DURTRAVref - DURTRAVref_co;
   DIFFrefNET=DURTRAVrefNET - DURTRAVrefNET_co;
   DIFFrefcj=DURTRAVrefCJ - DURTRAVrefCJ_co;run;

proc sort data=ET;by S DUREE;
proc summary data=ET(where=(-5<=DUREE<=10 ));
var DURTRAVref DURTRAVref_co DIFFref DURTRAVrefNET DURTRAVrefNET_co DIFFrefNET DURTRAVrefCJ DURTRAVrefCJ_co DIFFrefCJ;
by S DUREE;
output out=GG(drop=_TYPE_ _FREQ_) mean= stderr=DURTRAVref_std DURTRAVref_co_std	DIFFref_std DURTRAVrefNET_std DURTRAVrefNET_co_std
                            DIFFrefNET_std DURTRAVrefCJ_std DURTRAVrefCJ_co_std DIFFrefCJ_std;
proc print data=GG;
title "Values and standard errors - Figures B1 to B4 (web appendix)";
title2 "and values for Figures 2, 4, 5 and 7";run;

proc export data=GG outfile="c:\AER\Figures.xls" replace;
run;

  /* Figure B3 */
proc summary data=RES9209(where=((&controle ) and DATEpasse=0));
var DURTRAVref;
by S AN;
output out=RESY(drop=_TYPE_ _FREQ_) mean=DURTRAVref_co;
run;

data ETY;merge RES9209(in=_i1 where=(cjYEARTREATED ne '    ')) RESY;by S AN;
  if _i1; 

proc sort data=ETY;by S DUREE;
proc summary data=ETY(where=(-5<=DUREE<=10  and DATEpasse=0));
var DURTRAVref DURTRAVref_co;
by S DUREE;
output out=GGb3(drop=_freq_) mean= 	;
proc print data=GGb3;
title "Workweek duration - Values for Figure B3 ";
title2 "Sample of employed persons who were not treated at the same time as their spouse";
run;

proc export data=GGb3 outfile="c:\AER\Figures.xls" replace;
run;

  /* Figure B4 */
proc summary data=RES9209(where=((&controle) and PASSEQUAND='jamais ou n sa'));
var DURTRAVref ;
by S AN;
output out=RESZ(drop=_TYPE_ _FREQ_) mean=DURTRAVref_co ;
run;

data ETZ;merge RES9209(in=_i1 where=(cjYEARTREATED ne '    ')) RESZ;by S AN;
  if _i1; 

proc sort data=ETZ;by S DUREE;
proc summary data=ETZ(where=(-5<=DUREE<=10 and PASSEQUAND='jamais ou n sa'));
var DURTRAVref DURTRAVref_co;
by S DUREE;
output out=GGb4(drop=_freq_) mean= 	;
proc print data=GGb4;title "Work week duration - Values for Figure B4";
title2 "Sample of employed persons who were never treated";run;

proc export data=GGb4 outfile="c:\AER\Figures.xls" replace;
run;


   /* Figures 3 and 6 */
data ACT9209;set dinn.DOUBLEDIF5part(keep=AN S  ACTOCC PASSEQUANDcj cjYEARTREATED cjTREATED);
length DUREE 6;
  if cjTREATED=1 then DUREE=AN-cjYEARTREATED; else DUREE=0;
run; 

proc sort data=ACT9209; by S AN;

 
proc summary data=ACT9209(where=(&controle));
var ACTOCC;
by S AN;
output out=RESACT(drop=_TYPE_ _FREQ_) mean=ACTOCC_co/;
proc print data=RESACT;
title "Rate of employment";
run;

	 
data ET;merge ACT9209(in=_i1 where=(cjYEARTREATED ne '    ')) RESACT;by S AN;
  if _i1; 

proc sort data=ET;by S DUREE;
proc summary data=ET(where=(-5<=DUREE<=10 ));
var ACTOCC ACTOCC_co ;
by S DUREE;
output out=GGACT mean= stderr=ACTOCC_std ACTOCC_co_std;
proc print data=GGACT;title "Values for Figures 3 and 6";run;

proc export data=GGACT outfile="c:\AER\Figures.xls" replace;
run;
